package ema.tpjee.banking.test;

import java.util.List;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import ema.tpjee.banking.dao.BankDao;
import ema.tpjee.banking.model.Bank;
import ema.tpjee.banking.session.Session;

public class EjbTest {
	
	
	private static BankDao bankDao;
	
	
	public static void createEjbDao() {
		System.out.println("creating EjbDao");
		System.setProperty(Context.INITIAL_CONTEXT_FACTORY,
				"org.jnp.interfaces.NamingContextFactory");
		System.setProperty(Context.PROVIDER_URL, "localhost:1099");
		System.setProperty(Context.URL_PKG_PREFIXES,
				"org.jboss.naming:org.jnp.interfaces");
		try {
			bankDao = (BankDao) new InitialContext()
					.lookup("BankDaoImpl/remote");//tpejb4cEAR/BankDaoImpl/remote
			//bankDao.populate();
		} catch (NamingException e) {
			e.printStackTrace();
		}
	}
	
	
	private static void testEjbDao(){
		createEjbDao();
		bankDao.populate();
		List<Bank> banks=bankDao.getList();
		for (Bank b:banks){
			System.out.println(b);
		}
		System.out.println("end");	
	}
	
	
	
	private static void testSession(){
	    Session s = new Session();
	    List<Bank> banks= s.getBankControler().getBankDao().getList();
		for (Bank b:banks){
			System.out.println(b);
		}
		System.out.println("end");	
	}
		
	
	public static void main(String[]args){
	    //testEjbDao();
	    testSession();
		
	}

}
